$ sv_verify = f$verify("0''f$trnlnm("CP_VERIFY")'")
$ logit = f$integer("0''f$trnlnm("CP_LOG_ENABLE")'")
$ task_await = "$" + -
	f$parse("process_cache_await_task.exe;",f$environ("PROCEDURE"))
$ deass sys$input
$ if logit then write sys$output "Cached process ", f$getjpi("0","PID")
$!
$ task_status = 1
$ define /table=LNM$PROCESS_DIRECTORY LNM$FILE_DEV LNM$PROCESS, -
	APACHE_ENV, LNM$JOB, LNM$GROUP, LNM$SYSTEM, DEC$LOGICAL_NAMES
$ APACHE_ENV == "APE_"
$ next_task:
$    create/name/parent=LNM$PROCESS_DIRECTORY APACHE_ENV
$    on error then goto next_task_abort
$    call task_server "''P1'" "''P2'" "''task_status'"
$    task_status = $status
$    if logit then show logical/table=apache_env
$    deassign APACHE_ENV/table=LNM$PROCESS_DIRECTORY
$    goto next_task
$ next_task_abort:
$ deass /table=lnm$process_directory LNM$FILE_DEV
$ exit $status
$!
$ task_server: SUBROUTINE
$    task_status = 1
$    on warning then goto task_failure
$    task_await "''P1'" "''P2'" 600 "''P3'" "TASK"
$    if f$extract(0,1,f$edit(task_cmd,"TRIM")) .eqs. "/" then gosub cvtcmd
$    if task_in .nes. "" then define sys$input 'task_in'
$    if task_out .nes. "" then define sys$output 'task_out'
$    if task_err .nes. "" then define sys$error 'task_err'
$!
$    on warning then goto task_reset
$    write sys$output "x-vms-debug1: ProcessID=", f$getjpi("0","PID"), -
	", bytlm=", f$getjpi("0","BYTLM")
$    write sys$output "x-vms-debug2: in=''task_in' out=''task_out'err=",task_err
$    'task_cmd'
$    task_status = $status
$!
$ task_reset:
$    on warning then goto task_failure
$    if task_in .nes. "" then deass sys$input
$    if task_out .nes. "" then deass sys$output
$    if task_err .nes. "" then deass sys$error
$    exit 'task_status'
$!
$ task_failure:
$ exit '$status'
$!
$! Convert task_cmd string from unix specification to VMS.
$!
$ cvtcmd:
$    i = 1
$    cmd = f$element(1,"/","''task_cmd'")
$    prev_part = ""
$    delim = ":"
$ cvtcmd_next:
$	i = i + 1	! skip the NULL
$	part = "''f$element(i,"/",task_cmd)'"
$	if part .eqs. "/"
$	then
$	    delim = "]"
$	    if i .eq. 2 then delim = ""
$	    if i .eq. 3 then delim = ":"
$	    cmd = cmd + delim + prev_part
$	    cmd_type = f$edit(f$parse(cmd,".com",,"TYPE"),"UPCASE")
$	    if f$extract(0,4,cmd_type) .eqs. ".EXE" 
$	    then
$		task_cmd = "run " + cmd
$		if i .ge. 3 then task_cmd = -
		    "mcr " + cmd + " """ + f$trnlnm("PATH_INFO") + """"
$	    else
$		task_cmd = "@" + cmd
$	    endif
$	    return
$	endif
$	cmd = cmd + delim + prev_part
$	delim = "."
$	if prev_part .eqs. "" then delim = "["
$	prev_part = part
$	goto cvtcmd_next
$ ENDSUBROUTINE
