$ ! apache_install:[src]makefile.com
$
$ on warning then $exit
$
$
$ if "''P1'" .eqs. "CLEANUP"
$ then
$   gosub cleanup
$   exit
$ endif
$
$ arch = f$getsyi("ARCH_NAME")
$
$ cc_opts =	f$trnlnm("APACHE_CC_OPTIONS")
$ link_opts =	f$trnlnm("APACHE_LINK_OPTIONS")
$
$ if "''P1'" .eqs. "LINK"
$ then
$   goto link_only
$ endif
$
$ scratchFile := SYS$SCRATCH:APACHE_BUILD.TMP
$
$ exeFile := APACHE_INSTALL:[SRC]*.EXE_'arch'
$ if f$search("''exeFile'") .nes. ""
$ then
$      delete/nolog/noconfirm 'exeFile';*
$ endif
$
$ gosub createAutoConfig
$ gosub createDirs
$
$ 
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_OS_OPENVMS
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_AP
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_SUPPORT
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_MAIN
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_REGEX
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_MODULES_STANDARD
$ @APACHE_INSTALL:[SRC.OS.OPENVMS]MAKEFILE_SRC_MODULES_PROXY
$
$ gosub createModuleList
$
$ cc/prefix=all -
    /include=(apache_install:[src.include],apache_install:[src.os.openvms]) -
    /object=apache_install:[src.obj]modules.obj -
    /lis=apache_install:[lis] -
    'cc_opts -
    apache_install:[src]modules.c
$
$ cc/prefix=all -
    /include=(apache_install:[src.include],apache_install:[src.os.openvms]) -
    /object=apache_install:[src.obj]buildmark.obj -
    /lis=apache_install:[lis] -
    'cc_opts -
    apache_install:[src]buildmark.c
$
$ link_only:
$
$ link/exe=apache_install:[src]htpasswd.exe_'arch' -
	/map=apache_install:[lis]/full/cross -
    	'link_opts -
	apache_install:[src.support.obj]htpasswd.obj,-
	apache_install:[src.os.obj]libos/library,-
	apache_install:[src.ap.obj]libap/library
$
$ link/exe=apache_install:[src]apache_httpd.exe_'arch' -
	/map=apache_install:[lis]apache_httpd.map/full/cross -
    	'link_opts -
	apache_install:[src.main.obj]libmain/include=(http_main)/library,-
	apache_install:[src.ap.obj]libap/library,-
	apache_install:[src.regex.obj]libregex/library,-
	apache_install:[src.obj]buildmark.obj,-
	apache_install:[src.obj]modules.obj,-
        apache_install:[src.modules.standard.obj]libstandard/library,-
	apache_install:[src.modules.proxy.obj]libproxy/library,-
	apache_install:[src.os.obj]libos/library
$
$ Done: 
$   EXIT
$ !___________________________________________________________________________
$ createAutoConfig:
$
$   CHECK_FOR_HEADERS = " dlfcn.h dl.h bstring.h crypt.h unistd.h " + -
		      "sys/resource.h sys/select.h sys/processor.h"
$
$   save_verify = f$verify(0)
$
$   ! width=1 is a trick for getting one name per line
$   library/list='scratchFile'/width=1 SYS$LIBRARY:DECC$RTLDEF.TLB
$   open/write tmpOutFile apache_install:[src.include]ap_config_auto.h
$   open/read  tmpInFile 'scratchFile'
$
$   loop:
$     read/end_of_file=eof  tmpInFile line
$     if f$length(line) .eq. 0 then goto loop
$     pos = f$locate(line,f$edit(CHECK_FOR_HEADERS,"UPCASE"))
$     if pos .eq. f$length(CHECK_FOR_HEADERS) then goto loop
$     if (f$extract(pos-1,1,CHECK_FOR_HEADERS) .eqs. " " .or. -
		 f$extract(pos-1,1,CHECK_FOR_HEADERS) .eqs. "/")
$     then
$       if pos .ge. 4 .and. f$extract(pos-4,4,CHECK_FOR_HEADERS) .eqs. "sys/"
$       then
$	  pos = pos - 4
$	  len = f$length(line) + 4
$       else
$	  len = f$length(line)
$       endif
$       module = f$extract(pos,len,CHECK_FOR_HEADERS)                     
$       write tmpOutFile "#include <''module'.h>"
$       module = f$edit(module,"UPCASE")
$       pos2 = f$locate("/",module)
$       if pos2 .lt. f$length(module)
$       then
$         module = f$extract(0,pos2,module) + "_" +-
                   f$extract(pos2+1,f$length(module) - pos2-1,module)
$       endif
$       write tmpOutFile "#ifndef HAVE_''module'_H"
$       write tmpOutFile "#define HAVE_''module'_H"
$       write tmpOutFile "#endif"
$     endif
$   goto loop
$
$   eof:
$   close tmpInFile
$   delete/nolog/noconfirm 'scratchFile';*
$   close tmpOutFile
$
$   save_verify = f$verify('save_verify')
$ return
$ !__________________________________________________________________________
$ createDirs:
$ 
$   create/dire apache_install:[lis]
$
$   create/directory apache_install:[src.support.obj]
$   create/directory apache_install:[src.obj]
$   create/dire apache_install:[src.os.obj]
$   create/dire apache_install:[src.main.obj]
$   create/dire apache_install:[src.ap.obj]
$   create/dire apache_install:[src.regex.obj]
$   create/dire apache_install:[src.modules.standard.obj]
$   create/dire apache_install:[src.modules.proxy.obj]
$ return
$ !__________________________________________________________________________
$ cleanup:
$   set noon
$   if f$search("''scratchFile'") .nes. "" then -
$   	delete/nolog/noconfirm 'scratchFile'
$   delete/nolog/noconfirm apache_install:[lis]*.lis;*,*.map;*
$   delete/nolog/noconfirm apache_install:[000000]lis.dir;*
$   delete/nolog/noconfirm apache_install:[src.include]ap_config_auto.h;*
$   delete/nolog/noconfirm apache_install:[src]modules.c;*
$   delete/nolog/noconfirm apache_install:[src.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.support.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.support]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.os.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.os]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.main.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.main]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.ap.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.ap]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.regex.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.regex]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.modules.standard.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.modules.standard]obj.dir;*
$   delete/nolog/noconfirm apache_install:[src.modules.proxy.obj]*.*;*
$   delete/nolog/noconfirm apache_install:[src.modules.proxy]obj.dir;*
$
$ return
$ !__________________________________________________________________________
$ addPreLinkedModules:
$   library/list='scratchFile'/names/width=1 'thelib'
$   open/read tmpInFile 'scratchFile'
$   loop:
$     read/end_of_file=eof tmpInFile line
$     if f$extract(0,3,line) .eqs. "AP_" then goto loop
$     if line .eqs. "TOP_MODULE" then goto loop
$     if (f$locate("_MODULE",line) + f$length("_MODULE")) .eq. f$length(line)
$     then                     
$         write tmpOutFile "  &''line',"
$     endif
$     goto loop
$   eof:
$   close tmpInFile
$   delete/nolog/noconfirm 'scratchFile';*
$ return
$ !__________________________________________________________________________
$
$ addExternModulesDef:
$   library/list='scratchFile'/names/width=1 'thelib'
$   open/read tmpInFile 'scratchFile'
$   loop:
$     read/end_of_file=eof tmpInFile line
$     if f$length(line) .eq. 0 then goto loop
$     if line .eqs. "TOP_MODULE" then goto loop
$     if f$extract(0,3,line) .eqs. "AP_" then goto loop
$     if (f$locate("_MODULE",line) + f$length("_MODULE")) .eq. f$length(line)
$     then                     
$         write tmpOutFile "extern module ''line';"
$     endif
$     goto loop
$   eof:
$   close tmpInFile
$   delete/nolog/noconfirm 'scratchFile';*
$ return
$ !__________________________________________________________________________
$ createModuleList:
$   save_verify = f$verify(0)
$
$   open/write tmpOutFile apache_install:[src]modules.c
$
$   write tmpOutFile "/*"
$   write tmpOutFile " * modules.c --- automatically generated by Apache"
$   write tmpOutFile " * configuration script.  DO NOT HAND EDIT!!!!!"
$   write tmpOutFile " */"
$   write tmpOutFile ""
$   write tmpOutFile "#include ""httpd.h"""
$   write tmpOutFile "#include ""http_config.h""
$   write tmpOutFile ""
$
$   thelib = "apache_install:[src.main.obj]libmain.olb"
$   gosub AddExternModulesDef
$
$   thelib = "apache_install:[src.modules.standard.obj]libstandard.olb"
$   gosub AddExternModulesDef
$
$   thelib = "apache_install:[src.modules.proxy.obj]libproxy.olb"
$   gosub AddExternModulesDef
$
$   write tmpOutFile ""
$   write tmpOutFile "/*"
$   write tmpOutFile " *  Modules which implicitly form the"
$   write tmpOutFile " *  list of activated modules on startup,"
$   write tmpOutFile " *  i.e. these are the modules which are"
$   write tmpOutFile " *  initially linked into the Apache processing"
$   write tmpOutFile " *  [extendable under run-time via AddModule]"
$   write tmpOutFile " */"
$   write tmpOutFile "module *ap_prelinked_modules[] = {"
$
$   thelib = "apache_install:[src.main.obj]libmain.olb"
$   gosub AddPreLinkedModules
$
$   thelib = "apache_install:[src.modules.standard.obj]libstandard.olb"
$   gosub AddPreLinkedModules
$
$   thelib = "apache_install:[src.modules.proxy.obj]libproxy.olb"
$   gosub AddPreLinkedModules
$
$   write tmpOutFile "  NULL"
$   write tmpOutFile "};"
$   write tmpOutFile ""
$   write tmpOutFile "/*"
$   write tmpOutFile " *  Modules which initially form the"
$   write tmpOutFile " *  list of available modules on startup,"
$   write tmpOutFile " *  i.e. these are the modules which are"
$   write tmpOutFile " *  initially loaded into the Apache process"
$   write tmpOutFile " *  [extendable under run-time via LoadModule]"
$   write tmpOutFile " */"
$   write tmpOutFile "module *ap_preloaded_modules[] = {"
$   write tmpOutFile "  NULL"
$   write tmpOutFile "};"
$   write tmpOutFile ""
$
$   close tmpOutFile
$
$   save_verify = f$verify('save_verify)
$ return
$ !__________________________________________________________________________
$
$ ! End of file
